const float timer_timeout = 0.5;
bool is_teleporting = false;
bool blue_collision = false;
bool orange_collision = false;

class TeleportTimer
{
    void onTimerComplete()
    {
        if (is_teleporting && !blue_collision && !orange_collision)
            is_teleporting = false;

        blue_collision = false;
        orange_collision = false;

        Utils::logInfo("onTimerComplete");
        Utils::TimeoutCallback@ timerDelegate = Utils::TimeoutCallback(onTimerComplete);
        Utils::setTimeoutDelegate(timerDelegate, timer_timeout);
    }
}

void onStart()
{   
    TeleportTimer@ timer = TeleportTimer();
    Utils::TimeoutCallback@ timerDelegate = Utils::TimeoutCallback(timer.onTimerComplete);
    Utils::setTimeoutDelegate(timerDelegate, timer_timeout);
}

void bluePortalCollision(int idKart, const string libraryInstance, const string objID)
{
    blue_collision = true;

    if (is_teleporting)
        return;

    is_teleporting = true;

    Utils::logInfo("bluePortalCollision " + libraryInstance + " " + objID);
    Track::TrackObject@ obj = Track::getTrackObject("", "orange_portal");
    Vec3 pos = obj.getCenterPosition();
    Utils::logInfo("orange portal pos " + pos.getX() + " " +  pos.getY() + " " + pos.getZ());
    Kart::teleportExact(idKart, Vec3(pos.getX(), pos.getY(), pos.getZ()));
}

void orangePortalCollision(int idKart, const string libraryInstance, const string objID)
{
    orange_collision = true;

    if (is_teleporting)
        return;

    is_teleporting = true;

    Utils::logInfo("orangePortalCollision");
    Track::TrackObject@ obj = Track::getTrackObject("", "blue_portal");
    Vec3 pos = obj.getCenterPosition();
    Utils::logInfo("blue portal pos " + pos.getX() + " " +  pos.getY() + " " + pos.getZ());
    Kart::teleportExact(idKart, Vec3(pos.getX(), pos.getY(), pos.getZ()));
}
